#include <mysql.h>
#include <stdio.h>
#include <time.h>
#include "dht11.h"

MYSQL *conn;
	
int mysql_baglan(void) {
		
	MYSQL_RES *res;
	MYSQL_ROW row;

	// Veritabani parametreleri
	char *server = "localhost";
	char *user = "root";
	char *password = "root";
	char *database = "sensor";
	
	// Mysql hazirla
	conn = mysql_init(NULL);
	if (conn == NULL)
	{		
		fprintf(stderr, "%s\n", mysql_error(conn));
		return 0;
	}
	
	// Veritabanina baglan
	if (!mysql_real_connect(conn, server, user, password, database, 0, NULL, 0)) {
		fprintf(stderr, "%s\n", mysql_error(conn));
		return 0;
	}

	return 1;		
}

int main(void) {
		
	char sql[100];
	int last_temp, last_rh;
	int timestamp;
	
	// Veritaban baglantisini kur
	if (!mysql_baglan()) {
		printf("MySQL connection error!");
		exit(3306);
	}
	
	// wiringPi'yi hazirla
	if ( wiringPiSetup() == -1 ) {
		printf("wiringPiSetup error!");
		exit(3307);
	}
	
	// Sonsuz donguye gir
	while ( 1 ) {
		
		// -----------------------------
		// DHT11 sensorunu oku
		// -----------------------------
		if (read_dht11_dat()) {
			
			// Sicalik veya nem degismis mi?
			if ((last_temp != dht11_dat[2]) || (last_rh != dht11_dat[0])) {
			
				// SQL sorgusunu calistir
				sprintf (sql, "insert into logs (date, temp, rh) values (%d, %d,%d)", (int)time(NULL), dht11_dat[2], dht11_dat[0]);		
				printf("%s\n", sql);
				if (mysql_query(conn, sql)) {
					fprintf(stderr, "%s\n", mysql_error(conn));			
				}				
				last_temp = dht11_dat[2];
				last_rh = dht11_dat[0];
			}
		}
					
		// Tekrar okumak icin bekle
		delay(1 * 1000 );		
	}	
	
	return 0;
}